﻿//-----------------------------------------------------------------------
// <copyright>
// This file is subject to the terms and conditions of the Microsoft Public License (MS-PL).
// See http://www.microsoft.com/opensource/licenses.mspx#Ms-PL for more details.
// </copyright>
//----------------------------------------------------------------------- 
using System;

namespace Fulcrum.ControlGenerator
{
    public class RoutedEventDataContext
    {
        public RoutedEventDataContext(IRoutedEventConfiguration routedEventConfig)
        {
            this.EventArgsType = routedEventConfig.EventArgsType;
            this.HandlerType = routedEventConfig.HandlerType;
            this.Name = routedEventConfig.Name;
            this.Remarks = routedEventConfig.Remarks;
            this.RoutingStrategy = routedEventConfig.RoutingStrategy;
            this.Summary = routedEventConfig.Summary;
        }

        public string Name
        {
            get;
            private set;
        }

        public string Summary
        {
            get;
            private set;
        }

        public string Remarks
        {
            get;
            private set;
        }

        public string EventArgsType
        {
            get;
            private set;
        }

        public string RoutingStrategy
        {
            get;
            private set;
        }

        public string RoutedEventName
        {
            get
            {
                return String.Format("{0}Event", this.Name);
            }
        }

        public string HandlerType
        {
            get;
            private set;
        }
    }
}
