﻿//-----------------------------------------------------------------------
// <copyright>
// This file is subject to the terms and conditions of the Microsoft Public License (MS-PL).
// See http://www.microsoft.com/opensource/licenses.mspx#Ms-PL for more details.
// </copyright>
//----------------------------------------------------------------------- 

namespace Fulcrum.DispatcherProxies
{
    public class DispatcherProxyGenerationDataContext : GenerationDataContext
    {
        public DispatcherProxyGenerationDataContext(DispatcherProxySettings settings, DispatcherProxyTarget target)
        {
            this.Copyright = settings.Copyright;
            this.Company = settings.Company;
            this.Namespace = settings.Namespace;

            this.TargetType = target;
        }

        public DispatcherProxyTarget TargetType
        {
            get;
            private set;
        }

        public override string Name
        {
            get
            {
                return this.TargetType.WrappedType;
            }
        }

        public override string OutputFileName
        {
            get
            {
                return this.TargetType.ProxyName;
            }
        }

        public override string TemplateFileName
        {
            get
            {
                return "DispatcherProxies.t4";
            }
        }

        public string Namespace
        {
            get;
            private set;
        }

        public string Copyright
        {
            get;
            private set;
        }

        public string Company
        {
            get;
            private set;
        }
    }
}
