﻿//-----------------------------------------------------------------------
// <copyright>
// This file is subject to the terms and conditions of the Microsoft Public License (MS-PL).
// See http://www.microsoft.com/opensource/licenses.mspx#Ms-PL for more details.
// </copyright>
//----------------------------------------------------------------------- 
using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Fulcrum.UnitTests
{
    [TestClass]
    public class GenerationUnitTests
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentException))]
        public void TestConstructorNullName()
        {
            var genUnit = new MockGenerationUnit(null);
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentException))]
        public void TestConstructorEmptyName()
        {
            var genUnit = new MockGenerationUnit(String.Empty);
        }

        [TestMethod]
        public void TestConstructorName()
        {
            var genUnit = new MockGenerationUnit("GenUnit Name");

            Assert.AreEqual("GenUnit Name", genUnit.Name);
        }

    }
}
