﻿//-----------------------------------------------------------------------
// <copyright file="FulcrumTestEventSourceWeakEventManager.Generated.cs" company="Fulcrum Test">
//     Test Copyright.
// </copyright>
//  <auto-generated>
//      This code was generated by Fulcrum.WeakEventManager. DO NOT EDIT!
//
//      Changes to this file may cause incorrect behavior and will be lost if
//      the code is regenerated.
//  </auto-generated>
//-----------------------------------------------------------------------

namespace Fulcrum.UnitTests.WeakEventManager
{
    using System;
    using System.Windows;

    /// <summary>
    /// Provides a WeakEventManager implementation so that you can use the "weak event listener" pattern to attach listeners for the FulcrumTestEventSource.TestEvent event.
    /// </summary>
    class FulcrumTestEventSourceWeakEventManager : WeakEventManager
    {
        private FulcrumTestEventSourceWeakEventManager()
        {
            // nothing
        }

        /// <summary>
        /// Add a listener to the given source's event.
        /// </summary>
        /// <param name="source">The event source.</param>
        /// <param name="listener">The event listener.</param>
        public static void AddListener(FulcrumTestEventSource source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedAddListener(source, listener);
        }

        /// <summary>
        /// Remove a listener to the given source's event.
        /// </summary>
        /// <param name="source">The event source.</param>
        /// <param name="listener">The event listener.</param>
        public static void RemoveListener(FulcrumTestEventSource source, IWeakEventListener listener)
        {
            CurrentManager.ProtectedRemoveListener(source, listener);
        }

        /// <summary>
        /// Listen to the given source for the event.
        /// </summary>
        /// <param name="source">The event source.</param>
        protected override void StartListening(object source)
        {
            var typedSource = (FulcrumTestEventSource)source;
            typedSource.TestEvent += this.OnEventRaised;
        }

        /// <summary>
        /// Stop listening to the given source for the event.
        /// </summary>
        /// <param name="source">The event source.</param>
        protected override void StopListening(object source)
        {
            var typedSource = (FulcrumTestEventSource)source;
            typedSource.TestEvent -= this.OnEventRaised;
        }

        // get the event manager for the current thread
        private static FulcrumTestEventSourceWeakEventManager CurrentManager
        {
            get
            {
                Type managerType = typeof(FulcrumTestEventSourceWeakEventManager);
                var manager = (FulcrumTestEventSourceWeakEventManager)GetCurrentManager(managerType);

                // at first use, create and register a new manager
                if (manager == null)
                {
                    manager = new FulcrumTestEventSourceWeakEventManager();
                    SetCurrentManager(managerType, manager);
                }

                return manager;
            }
        }

        private void OnEventRaised(object sender, EventArgs args)
        {
            DeliverEvent(sender, args);
        }
    }
}

