﻿//-----------------------------------------------------------------------
// <copyright>
// This file is subject to the terms and conditions of the Microsoft Public License (MS-PL).
// See http://www.microsoft.com/opensource/licenses.mspx#Ms-PL for more details.
// </copyright>
//----------------------------------------------------------------------- 
using System.IO;
using Fulcrum.WeakEventManager;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Fulcrum.UnitTests.WeakEventManager
{
    [DeploymentItem("WeakEventManager.t4")]
    [DeploymentItem("TestWeakEventManagerConfig.xml")]
    [DeploymentItem("FulcrumTestEventSourceWeakEventManager.Generated.cs")]
    [TestClass]
    public class WeakEventManagerGeneratedCodeTests : FulcrumGeneratedCodeTests
    {
        public WeakEventManagerGeneratedCodeTests()
        {
            // nothing
        }

        [TestMethod]
        public void ValidateDifferentInGeneratedCode()
        {
            ValidateGeneratedCode();
        }

        protected override GenerationUnit CreateGenerationUnit(string path)
        {
            var wemGenUnit = new WeakEventManagerGenerationUnit();
            var wemSettings = (WeakEventManagerSettings)wemGenUnit.Settings;

            wemSettings.ConfigFileName = Path.Combine(path, "TestWeakEventManagerConfig.xml");
            return wemGenUnit;
        }

    }
}
